<template>
    <div>
        <base-header type="gradient-yellow" class="pb-6 pb-8 pt-5 pt-md-6">
            <!-- Card stats -->
            <div class="row">
                <div class="col-xl-3 col-lg-6">
                    <stats-card title="Materializations"
                                type="gradient-red"
                                :sub-title="numMzs"
                                icon="fa fa-cubes"
                                class="mb-4 mb-xl-0"
                    >

                        <template slot="footer">
                            <span class="text-success mr-2"><i class="fa fa-spinner"></i> {{numTasks}} </span>
                            <span class="text-nowrap">Tasks in progress</span>
                        </template>
                    </stats-card>
                </div>
                <div class="col-xl-3 col-lg-6">
                    <stats-card title="Nodes In Use"
                                type="gradient-orange"
                                :sub-title="nodeInfo.inuse"
                                icon="fa fa-server"
                                class="mb-4 mb-xl-0"
                    >

                        <template slot="footer">
                            <span class="text-success mr-2"><i class="fa fa-save"></i> {{nodeInfo.imaging}} </span>
                            <span class="text-nowrap">Nodes imaging</span>
                        </template>
                    </stats-card>
                </div>
                <div class="col-xl-3 col-lg-6">
                    <stats-card title="Virtual Links"
                                type="gradient-green"
                                :sub-title="linkInfo.total"
                                icon="fa fa-share-alt"
                                class="mb-4 mb-xl-0"
                    >

                        <template slot="footer">
                            <span class="text-success mr-2"><i class="fa fa-tachometer-alt"></i> {{linkInfo.emulated }} </span>
                            <span class="text-nowrap">Emulated Links</span>
                        </template>
                    </stats-card>

                </div>
                <div class="col-xl-3 col-lg-6">
                    <stats-card title="XDC Connections"
                                type="gradient-info"
                                :sub-title="xdcInfo.count"
                                icon="fa fa-users"
                                class="mb-4 mb-xl-0"
                    >

                        <template slot="footer">
                            <span class="text-success mr-2"><i class="fa fa-shield-alt"></i> {{ xdcInfo.materializations }} </span>
                            <span class="text-nowrap"> Endpoints </span>
                        </template>
                    </stats-card>
                </div>
            </div>
        </base-header>

        <!--Tables-->
        <div class="row mt-5">
            <div class="col-xl-8 mb-5 mb-xl-0">
                <materialization-table title="Light Table"></materialization-table>
            </div>
            <div class="col-xl-4">
                <images-table></images-table>
            </div>
        </div>
        <!--End tables-->
    </div>

</template>
<script>
  import MaterializationTable from './Tables/MaterializationTable'
  import ImagesTable from './Tables/ImagesTable'
  const axios = require('axios').default;

  export default {
    components: {
      MaterializationTable,
      ImagesTable,
    },
    data() {
      return {
        nodeInfo: {
            total: "",
            imaging: "",
            inuse: "",
        },
        linkInfo: {
            total: "",
            emulated: "",
        },
        xdcInfo: {
            count: "",
            materializations: "",
        },
        numMzs: "",
        numTasks: "",
      };
    },
    methods: {
      initCards() {

        axios.get(location.origin+"/api/materializations")
             .then( x => this.numMzs = x.data.length.toString() )

        axios.get(location.origin+"/api/tasks")
             .then( x => this.numTasks = x.data.length.toString() )

        axios.get(location.origin+"/api/links")
             .then( x => {
                this.linkInfo = {
                    total: x.data.total.toString(),
                    emulated: x.data.emulated.toString(),
                }
            })

        axios.get(location.origin+"/api/wgd/summary")
             .then( x => {
                this.xdcInfo = {
                    count: x.data.count.toString(),
                    materializations: x.data.materializations.toString(),
                }
            })

        axios.get(location.origin+"/api/nodes")
             .then( x => {
                var total = 0;
                var imaging = 0;
                var inuse = 0;

                for (const d of x.data) {
                    total++;
                    if (!d.Mzid.includes("harbor")) {
                        inuse++;
                    }
                    if (d.Status.Current != d.Status.Target) {
                      imaging++;
                    }
                }

                this.nodeInfo = {
                    total: total.toString(),
                    imaging: imaging.toString(),
                    inuse: inuse.toString(),
                }

             })

      }
    },
    mounted() {
      this.initCards();
    }
  };
</script>
<style></style>
